package com.myorg.web.tags;
import com.myorg.web.utils.RenderUtils;
import org.dd4t.contentmodel.exceptions.ItemNotFoundException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.SimpleTagSupport;
import java.io.IOException;
import java.util.Locale;

/**
 * Components presentation rendering tag
 */
public class DynamicComponentPresentationTag extends SimpleTagSupport {

    private static final Logger LOG = LoggerFactory.getLogger(DynamicComponentPresentation2Tag.class);
    private String component;
    private String view;


    @Override
    public void doTag() throws JspException, IOException {
        PageContext pageContext = (PageContext) getJspContext();
        try {
            HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();
            HttpServletResponse response = (HttpServletResponse) pageContext.getResponse();

            String out = RenderUtils.renderComponentPresentation(request, response, component, view);
            pageContext.getOut().write(out);
        } catch (ItemNotFoundException e) {
            LOG.warn("Item not found: {}. Error was: {}", component, e.getMessage());
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public String getComponent() {
        return component;
    }

    public void setComponent(final String component) {
        this.component = component;
    }

    public String getView() {
        return view;
    }

    public void setView(final String view) {
        this.view = view.toLowerCase(Locale.getDefault());
    }

}
