package com.myorg.web.utils;

import org.dd4t.contentmodel.exceptions.ItemNotFoundException;
import org.dd4t.core.services.LabelService;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;
import java.io.CharArrayWriter;
import java.io.IOException;
import java.io.PrintWriter;


public class RenderUtils {
    private static LabelService labelService = null;
    public static String renderComponentPresentation(final HttpServletRequest request, final HttpServletResponse response, final String componentURI, final String viewName) throws ItemNotFoundException, ServletException, IOException {
        String url = String.format("/%s/%s.dcp", viewName, componentURI);
        return dispatchBufferedRequest(request, response, url);
    }

    private static String dispatchBufferedRequest(final HttpServletRequest request, final HttpServletResponse response, final String url) throws ServletException, IOException {
        RequestDispatcher dispatcher = request.getServletContext().getRequestDispatcher(url);
        HttpServletResponse responseWrapper = new HttpServletResponseWrapper(response) {
            private CharArrayWriter output = new CharArrayWriter();

            @Override
            public String toString() {
                return output.toString();
            }

            @Override
            public PrintWriter getWriter() {
                return new PrintWriter(output);
            }
        };

        dispatcher.include(request, responseWrapper);
        return responseWrapper.toString();
    }
}
